const tools = require("../script/tools");


cc.Class({
    extends: cc.Component,

    properties: {
        label: cc.Label,
        tipClip: cc.AudioClip
    },

    data: null,
    onLoad() {

    },

    onEnable() {
        this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchStart, this)
        cc.systemEvent.on('changeAnswerState', this.onChangeState, this)
    },

    onDisable() {
        this.node.off(cc.Node.EventType.TOUCH_START, this.onTouchStart, this)
        cc.systemEvent.off('changeAnswerState', this.onChangeState, this)
    },

    initWithData(data, scale) {
        this.data = data
        let rect = this.data.rect
        this.node.x = rect.x * scale
        this.node.y = -rect.y * scale
        this.node.width = rect.width
        this.node.height = rect.height
        this.node.scale = data.fontScale ? data.fontScale * scale : scale
        let action = data['actionData_']
        this.label.string = action.text ? action.text : ''
        this.label.node.active = false
        let option = action.changeOption
        this.label.node.color = option[0][1] ? cc.color(option[0][1]) : cc.color(0, 0, 0)
    },

    onTouchStart() {
        this.label.node.active = true
        cc.audioEngine.play(this.tipClip)
    },

    /** 改变答案显示状态 */
    onChangeState(show) {
        this.label.node.active = show
    }
});
