const tools = require("../script/tools");

cc.Class({
    extends: cc.Component,

    properties: {
        label: cc.Label,
        playAnim: cc.Animation
    },

    data: null,

    audio_url: null,

    onEnable() {
    },

    onDisable() {

    },

    initWithData(data, scale) {
        this.data = data
        let rect = this.data.rect
        this.node.x = (rect.x + rect.width / 2) * scale
        this.node.y = (-rect.y - rect.height / 2) * scale
        let action = data['actionData_']
        let node = this.label.node
        let option = action.changeOption
        node.color = option[0][1] ? cc.color(option[0][1]) : cc.color(0, 0, 0)
        node.scale = data.fontScale ? data.fontScale*scale : scale
        this.label.string = action.text ? action.text : ''
        this.node.width = node.width * node.scale
        this.node.height = node.height * node.height
        this.audioId = null
        this.audio_url = action.audio_url
        if (this.audio_url) {
            let node = this.playAnim.node
            node.scale = 1 / this.node.scale
            node.setPosition(this.label.node.width + node.width / 2 + 15, -this.node.height / 2)
            this.playAnim.node.active = true
        } else {
            this.playAnim.node.active = false
        }
    },

    onTouchStart() {
        if (this.audioId) return
        if (this.audio_url && this.audio_url != '') {
            this.playAudio(this.audio_url)
            this.playAnim.play('play')
        }
    },

    /** 播放音乐 */
    playAudio(url) {
        cc.assetManager.loadRemote(url, (err, audioClip) => {
            if (err) return
            cc.systemEvent.once('stopMusic', this.stopAudio, this)
            this.audioId = cc.audioEngine.play(audioClip, false, 0.8);
            cc.audioEngine.setFinishCallback(this.audioId, this.stopAudio.bind(this));
        });
    },

    stopAudio() {
        if (this.audioId != null) {
            cc.audioEngine.stop(this.audioId)
            this.audioId = null
            this.playAnim.play('stop')
            cc.systemEvent.off('stopMusic', this.stopAudio, this)
        }
    },
    /** 音频id */
    audioId: null,
});
